﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Threading;
using Ascon.Pilot.SDK.CreateObjectSample;

namespace Ascon.Pilot.SDK.FileSnapshotSample
{
    class DocumentHistoryViewModel  : HistoryViewModel
    {
        public DocumentHistoryViewModel(Guid dataObjectId, IObjectsRepository repository, IObjectModifier modifier, Dispatcher dispatcher) 
            : base(dataObjectId, repository, modifier, dispatcher)
        {
        }

        public override string Title
        {
            get { return "Document versions"; }
        }

        protected override void CreateVersion()
        {
            var filter = string.Empty;
            filter += "Supported files (*.xps;*.dwfx;*.pdf)|*.xps;*.dwfx;*.pdf|";
            filter += "XPS Documents (*.xps)|*.xps|";
            filter += "DWFx Documents (*.dwfx)|*.dwfx|";
            filter += "PDF Documents (*.pdf)|*.pdf";
            var title = "Open existing document";

            List<string> filePaths;
            if (ShowOpenFileDialog(title, filter, false, null, out filePaths) == true)
            {
                var filePath = filePaths[0];
                var loader = new ObjectLoader(_repository);
                loader.Load(_dataObjectId, o =>
                {
                    string reason;
                    if (ShowReasonDialog(o, out reason) == false)
                        return;

                    using (var stream = File.OpenRead(filePath))
                    {
                        var name = Path.GetFileName(filePath);
                        _modifier.Edit(o).CreateFileSnapshot(reason).AddFile(name, stream, DateTime.UtcNow, DateTime.UtcNow, DateTime.UtcNow);
                        _modifier.Apply();
                    }
                });
            }
        }
    }
}
