﻿using System.ComponentModel.Composition;
using System.Diagnostics;
using System.Text;
using System.Windows;
using Ascon.Pilot.SDK.CreateObjectSample;

namespace Ascon.Pilot.SDK.PrinterSample
{
    [Export(typeof(IPrintHandler))]
    public class PrintHandler: IPrintHandler
    {
        private readonly IObjectsRepository _repository;

        [ImportingConstructor]
        public PrintHandler(IObjectsRepository repository)
        {
            _repository = repository;
        }

        public bool Handle(IPrintedDocumentInfo printTicket)
        {
            var message = new StringBuilder();
            message.AppendLine("We not allow to print document");
            message.Append("NAME: ");
            message.AppendLine(printTicket.PrinterSettings.PrintJobName);
            message.Append("ID: ");
            message.Append(printTicket.DocumentId);

            MessageBox.Show(message.ToString(), "Something works", MessageBoxButton.OK, MessageBoxImage.Information);

            var loader = new ObjectLoader(_repository);
            loader.Load(printTicket.DocumentId, obj =>
            {
                foreach (var file in obj.Files)
                {
                    Debug.Print("Name: " + file.Name);
                }
            });
            return true;
        }
    }
}