﻿using System;
using System.ComponentModel;
using Ascon.Pilot.SDK.TaskSample.Annotations;

namespace Ascon.Pilot.SDK.TaskSample.TaskEditView
{
    public class ExecutorItem : INotifyPropertyChanged
    {
        public int OrgUnitId { get; private set; }
        public string Title { get; private set; }

        public ExecutorItem(int orgUnitId, string title)
        {
            OrgUnitId = orgUnitId;
            Title = title;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }

        public override bool Equals(object obj)
        {
            var other = obj as ExecutorItem;
            return other != null && other.OrgUnitId == OrgUnitId;
        }

        public override int GetHashCode()
        {
            return OrgUnitId.GetHashCode();
        }
    }

    public class NewExecutorItem : ExecutorItem
    {
        public NewExecutorItem() : base(-1, string.Empty)
        {
        }
    }

    public class NewAuditorItem : ExecutorItem
    {
        public NewAuditorItem() : base(-1, string.Empty)
        {
        }
    }
}
