﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Ascon.Pilot.SDK.TaskSample.TaskEditView
{
    class ReviewTaskEditViewModel : TaskEditViewModel
    {
        public ReviewTaskEditViewModel(ITaskModifier taskModifier, IObjectsRepository repository, 
            IPilotDialogService pilotDialogService, ITabServiceProvider tabServiceProvider) 
            : base(taskModifier, repository, pilotDialogService, tabServiceProvider)
        {
        }

        public override bool SubmitTask()
        {
            if (!CanSubmit)
                return false;

            var executors = _executorItems.Where(x => x.OrgUnitId != -1).Select(x => x.OrgUnitId).ToList();
            var attachments = Attachments.Select(x => x.Id);
            var auditorIds = _auditorsItems.Where(a => a.OrgUnitId != -1).Select(a => a.OrgUnitId).ToList();
            var workFlow = _taskModifier.NewWorkflow().SetTitle(Title).SetDescription(Description).SetInitiatorAttachments(attachments.ToList());
            var stage = _taskModifier.NewStage(workFlow.WorkflowObject).SetStageOrder(1);
            foreach (var executorItemId in executors)
            {
                var buider = _taskModifier.NewTask(workFlow.WorkflowObject, stage.StageObject, executorItemId);
                buider.SetKind(TaskKind.Acquaintance);
                buider.SetAuditors(auditorIds);
            }

            _taskModifier.Apply();
            return true;
        }
    }
}
