﻿using System;
using System.ComponentModel.Composition;
using System.Linq;
using System.Windows;
using Ascon.Pilot.SDK.Toolbar;

namespace Ascon.Pilot.SDK.ToolbarSample
{
    [Export(typeof(IToolbar<LinkedObjectsContext>))]
    public class LinkedObjectsToolbarSample : IToolbar<LinkedObjectsContext>
    {
        private const string MENU_ITEM_NAME = "miShowInfo";

        public void Build(IToolbarBuilder builder, LinkedObjectsContext context)
        {
            builder.AddButtonItem(MENU_ITEM_NAME, builder.Count).WithHeader("Показать информацию");
        }

        public void OnToolbarItemClick(string name, LinkedObjectsContext context)
        {
            if (name == MENU_ITEM_NAME)
            {
                MessageBox.Show($"Выбрано элементов: {context.SelectedObjects.Count()}");
            }
        }
    }
}
