﻿using System;
using Ascon.Pilot.SDK;
using ProjectCloneWizard.Data;

namespace ProjectCloneWizard.ObjectCardView.ReferenceBook
{
    public class ListViewTypeFilter 
    {
        private readonly Func<IObjectsRepository> _getRepository;

        public ListViewTypeFilter(Func<IObjectsRepository> getRepository)
        {
            _getRepository = getRepository;
        }

        public bool Matches(int typeId)
        {
            var type = _getRepository().GetType(typeId);
            return Matches(new DataType(type));
        }

        private bool Matches(DataType type)
        {
            if (type.Name == SystemTypeNames.SMART_FOLDER)
                return true;
            if (type.Name == SystemTypeNames.SHORTCUT)
                return true;
            return !type.IsService && type.Kind == TypeKind.User;
        }
    }
}
